(function ($,global) 
{
	var app = global.app = global.app || {}
		,homeModel,categoryModel,articleModel, meteoModel, archiveModel,settingsModel
		,categoryBoutPortantModel,pharmacieModel,changeModel,pompierModel,filInfoModel,flashInfoModel;
	
	function showLoading(){
		app.application.showLoading();
	}
	function hideLoading()
	{
		setTimeout(function() 
		{
			app.application.hideLoading();
		}, 100);
	}

	var downloadClass = function(){};

	downloadClass.prototype = {
		run : function(linkToDownload, fileName, folderName)
		{						
			var that = this, filePath ;
			that.getFilesystem(
				function(fileSystem)
				{
					if (device.platform === "Android") 
					{
						that.getFolder(fileSystem, folderName, function(folder) 
						{
							filePath = folder.toURL() + "\/" + fileName;
							that.transferFile(linkToDownload, filePath, fileName, folder.toURL());
						}, function() {
							navigator.notification.alert("Impossible de trouver le dossier de téléchargement"
									,null
									,"Téléchargement"
									,"OK");
						});
					} else {
						var filePath;
						var urlPath = fileSystem.root.toURL();
						if (device.platform == "Win32NT") {
							urlPath = fileSystem.root.fullPath;
						}
						if (parseFloat(device.cordova) <= 3.2) {
							filePath = urlPath.substring(urlPath.indexOf("/var")) + "\/" + fileName;
						} else {
							filePath = urlPath + "\/" + fileName;
						}
						that.transferFile(linkToDownload, filePath, fileName,urlPath)
					}
				},function()
				{
					navigator.notification.alert("Impossible de démarrer le téléchargement"
						,null
						,"Téléchargement"
						,"OK");
				});
		}
		,getFilesystem : function (success, fail) 
		{
			window.requestFileSystem = window.requestFileSystem || window.webkitRequestFileSystem;
			window.requestFileSystem(LocalFileSystem.PERSISTENT, 0, success, fail);
		}
		,getFolder : function (fileSystem, folderName, success, fail) 
		{
			fileSystem.root.getDirectory(folderName, {create: true, exclusive: false}, success, fail);
		}
		,transferFile : function(linkToDownload, filePath, fileName,folder)
		{
			var transfer = new FileTransfer();
			transfer.download(linkToDownload
					,filePath
					,function(entry)
					{
						hideLoading();
						var targetPath = entry.toURL();
						if (device.platform == "Win32NT") {
							targetPath = entry.fullPath;
						}
						navigator.notification.alert("Fichier téléchargé avec succès dans " + folder);
						cordova.plugins.fileOpener2.open(decodeURI(targetPath),"application/pdf",{
							error : function(e){
								navigator.notification.alert("Impossible d'ouvrir le fichier "+ decodeURI(targetPath)+ ", Erreur : "+e.message);
							}
						});
					}
					,function(error)
					{
						hideLoading();
						var __msg = "Erreur de téléchargement : source " + error.source+", cible : " + error.target+ ", code : " + error.code;
						navigator.notification.alert(__msg,null,"Téléchargement archive","OK");
					});
		}
	};

	var mainClass   = mainClass  || {
		settings : {}
		,init : function()
		{
			var self 	 = this;
			var settings = {};
			window.localStorage.clear();
			if(window.localStorage.getItem("settings") == undefined || window.localStorage.getItem("settings") == null 
				|| window.localStorage.getItem("settings") == "")
			{
				$.ajax({
					url 	  : "config/configuration.json"
					,type 	  : "get"
					,dataType : "JSON"
					,async	  : false
					,success  : function(configValue){
						settings = $.extend(settings,configValue);
					}
				});
				window.localStorage.setItem("settings",JSON.stringify(settings));
			}
			self.settings = JSON.parse(window.localStorage.getItem("settings"));
		
		}
		,_showFooterMenu 		: function()
		{
			var self = this;
			var bottomMenuToShow = self.settings.Application.bottomMenuToShow;
			var __htmlToRender   = "<footer data-role=\"footer\" class=\"footer\"><div data-role=\"tabstrip\">";
			var selectedMenu	 = [];
			$.each(bottomMenuToShow,function(i,elem){
				if(elem.show){
					var _obj = {"libelle":elem.libelle,"icon":elem.icon,"lien":elem.link,"modal":elem.modal};
					selectedMenu.push(_obj);
				}
			});
			var template = kendo.template("<a href=\"#:lien#\" #if(modal){#data-rel=\"modalview\"#}# data-role=\"button\" data-align=\"left\" data-icon=\"#:icon#\">#:libelle#</a>");
			
			var dataSource = new kendo.data.DataSource({
				data: selectedMenu
				,cache:false
				,change: function() { 
					$("#footerTabstrip").html(kendo.render(template, this.view()));
					$("#footerTabstrip").kendoMobileTabStrip();
				}
			});
			dataSource.read();
		}
		,_prepareDataForRequest : function()
		{
			var self = this;
			var url = "";
			url += (self.settings.WebService.securisedUrl)?"https://":"http://";
			url += self.settings.WebService.domain+"/";
			url += ((self.settings.WebService.baseDir != "")?self.settings.WebService.baseDir+"/":"");
			url += "index.php";
			var defaultData 	= {
					"option"	:"com_api"
					,"app"		:"content"
					,"format"	:"raw"
					,"key"		:self.settings.WebService.key
			}
			return {"url":url
				    ,"data":defaultData};
		}
		,_defaultDataSourceParameters : function()
		{
			var self = this;
			return {
				transport : {
					read : {
						url 		: self._prepareDataForRequest().url
						,type 		: "get"
						,dataType 	: "jsonp"
						,data		: self._prepareDataForRequest().data
					}
				}
			};
		}
	};
	
	mainClass.init();

	homeModel = kendo.data.ObservableObject.extend({
		homeSource 	  : null
		,homeSourceXs : null 
		,init 	   : function()
		{
			var that = this,
				dataSource,dataSourceXs;
			
			kendo.data.ObservableObject.fn.init.apply(that, []);
			
			var data 						= mainClass._defaultDataSourceParameters();
			data.schema						= {data : "categories"};
			data.transport.read.data  		= $.extend(data.transport.read.data,{
												resource	:"category"
												,to			:"home"
											});
			
			dataSource = new kendo.data.DataSource($.extend(data,{
				requestStart : function(){ showLoading();}
				,requestEnd : function(){ hideLoading();}
			}));
			var dataXs						= mainClass._defaultDataSourceParameters();
			dataXs.schema					= {data : "categories"};
			dataXs.transport.read.data  	= $.extend(dataXs.transport.read.data,{
												resource	:"category"
												,to			:"home"
												,xs			: 1
											});
			dataSourceXs = new kendo.data.DataSource($.extend(dataXs,{
				requestStart : function(){ showLoading();}
				,requestEnd : function(){ hideLoading();}
			}));
			
			that.set("homeSource", dataSource);	
			that.set("homeSourceXs", dataSourceXs);
		}		
	});
	categoryModel = kendo.data.ObservableObject.extend(
	{
		categorySource : null
		,init		  : function()
		{
			var that = this,
				dataSource;
				
			kendo.data.ObservableObject.fn.init.apply(that, []);
			
			var data 						= mainClass._defaultDataSourceParameters();
			data.schema						= {data : "articles",total:"total"};
			data.transport.read.data  		= $.extend(data.transport.read.data,{
												resource	:"category"
												,to			:"category"
											});
			
			dataSource = new kendo.data.DataSource($.extend(data,
			{
				pageSize	  : 15
				,serverPaging : true
				,group 		  : {field:"category"}
				,requestStart : function(){
					showLoading();
				}
				,requestEnd : function(){
					hideLoading();
				}
			}
			));
			that.set("categorySource", dataSource);	
		}
	});
	filInfoModel 			 = kendo.data.ObservableObject.extend(
	{
		filInfoSource : null
		,init		  : function()
		{
			var that = this,
				dataSource;
				
			kendo.data.ObservableObject.fn.init.apply(that, []);
			
			var data 						= mainClass._defaultDataSourceParameters();
			data.schema						= {data : "articles",total:"total"};
			data.transport.read.data  		= $.extend(data.transport.read.data,{
												resource	:"infos"
												,to			:"fil"
											});
			dataSource = new kendo.data.DataSource($.extend(data,
			{
				pageSize	  : 15
				,serverPaging : true
				,requestStart : function(){
					showLoading();
				}
				,requestEnd : function(){
					hideLoading();
				}
			}
			));
			that.set("filInfoSource", dataSource);	
		}
	});
	
	flashInfoModel = kendo.data.ObservableObject.extend(
	{
		flashInfoSource : null
		,init		  : function()
		{
			var that = this,
				dataSource;
				
			kendo.data.ObservableObject.fn.init.apply(that, []);
			
			var data 						= mainClass._defaultDataSourceParameters();
			data.schema						= {data : "articles",total:"total"};
			data.transport.read.data  		= $.extend(data.transport.read.data,{
												resource	:"infos"
												,to			:"flash"
											});
			
			dataSource = new kendo.data.DataSource($.extend(data,
			{
				pageSize	  : 15
				,serverPaging : true
				,requestStart : function(){
					showLoading();
				}
				,requestEnd : function(){
					hideLoading();
				}
			}
			));
			that.set("flashInfoSource", dataSource);	
		}
	});
	categoryBoutPortantModel = kendo.data.ObservableObject.extend(
	{
		imageSource : null
		,init		: function()
		{
			var that = this, dataSource;
			
			kendo.data.ObservableObject.fn.init.apply(that, []);
			
			var dataBoutPortant				= mainClass._defaultDataSourceParameters();
			dataBoutPortant.schema						= {data : "articles"};
			dataBoutPortant.transport.read.data  		= $.extend(dataBoutPortant.transport.read.data,{
												resource	:"category"
												,to			:"category"
												,type		:"galery"
											});
			
			dataSource = new kendo.data.DataSource(dataBoutPortant);
			that.set("imageSource", dataSource);	
			that.get("imageSource").read();
		}
	});
	
	archiveModel = kendo.data.ObservableObject.extend(
	{
		archiveSource : null
		,init		  : function()
		{
			var that = this,dataSource;
			
			kendo.data.ObservableObject.fn.init.apply(that,[]);
			var data = mainClass._defaultDataSourceParameters();
			data.transport.read.data = $.extend(data.transport.read.data,{
				resource : "archives"
			});
			data.schema	= {data : "items",total:"total"};
			dataSource = new kendo.data.DataSource(data);
			that.set("archiveSource",dataSource);
		}
	});
	settingsModel = kendo.data.ObservableObject.extend(
	{
		settingsSource : null
		,init		   : function()
		{
			var that = this, dataSource;
			
			kendo.data.ObservableObject.fn.init.apply(that, []);
			var data 		= mainClass.settings.Application.bottomMenuToShow;
			var dataToPass 	= [];
			$.each(data,function(i,elem){
				var __tempObj = {libelle:elem.libelle,name:elem.name,show:elem.show};
				dataToPass.push(__tempObj);
			});
			var dataSource 	= new kendo.data.DataSource({data : dataToPass,cache:false});
			that.set("settingsSource",dataSource);
			that.get("settingsSource").read();
		}
	});
	menuModel = kendo.data.ObservableObject.extend(
	{
		menu 		 : null
		,init		 : function()
		{
			var that = this,
				dataSource;
			
			kendo.data.ObservableObject.fn.init.apply(that, []);			
			var data 						= mainClass._defaultDataSourceParameters();
			data.transport.read.data  		= $.extend(data.transport.read.data,{
												resource	:"category"
												,to			:"menu"
											});
			
			dataSource = new kendo.data.DataSource(data);
			dataSource.read();
			that.set("menu", dataSource);	
		}
	});
	commentsModel = kendo.data.ObservableObject.extend(
	{
		comments : null
		,idArticle : null
		,init	 : function()
		{
			var that = this,
				dataSource;
				
			kendo.data.ObservableObject.fn.init.apply(that, []);
			
			var data					= mainClass._defaultDataSourceParameters();
			data.transport.read.data 	= $.extend(data.transport.read.data,{
												resource : "comment"
											});
			
			dataSource = new kendo.data.DataSource($.extend(data
			,{
				change : function()
				{
					if(parseInt(this.total()) == 0)
					{
						$("#no-comments").show();						
					}else{
						$("#commentsList").html(kendo.render(kendo.template($("#comment-page-template").html()), this.view()));
					}
				}
				,requestStart : function(){
					showLoading();
				}
				,requestEnd : function(){
					hideLoading();
				}
			}));
			that.set("comments", dataSource);	
		}
	});
	articleModel = kendo.data.ObservableObject.extend(
	{
		article : null
		,init	: function()
		{
			var that = this,
				dataSource;
			
			kendo.data.ObservableObject.fn.init.apply(that, []);
			
			var data 						= mainClass._defaultDataSourceParameters();
			data.transport.read.data  		= $.extend(data.transport.read.data,{
												resource	:"article"
												,to			:"article"
											});
			
			dataSource = new kendo.data.DataSource($.extend(data
			,{
				change : function(e)
				{
					$("#articleContainer").html(kendo.render(kendo.template($("#article-page-template").html()), this.view()));
					var data 		= this.data()[0];
					if(data.previousItem != undefined)
					{
						$("#previousArticle").attr(
						{
							"href" 		: "views/article.html?id="+data.previousItem
							,"style"	: "display:block"
						});
					}else{					
						$('#previousArticle').attr("style","display:none");
					}
					
					if(data.nextItem != undefined)
					{
						$("#nextArticle").attr(
						{
							"href" 		: "views/article.html?id="+data.nextItem
							,"style"	: "display:block"
						});
					}else{
						$("#nextArticle").attr("style","display:none");
					}
					$("#commentsArticle").data("id",data.id);
				}
				,requestStart : function(){
					showLoading();
				}
				,requestEnd : function()
				{
					hideLoading();
				}
			}));
			that.set("article", dataSource);	
		}

	});
	meteoModel = kendo.data.ObservableObject.extend(
	{
		meteo : null
		,init	: function()
		{
			var that = this,
				dataSource;
			
			kendo.data.ObservableObject.fn.init.apply(that, []);
			
			var data 						= mainClass._defaultDataSourceParameters();
			data.transport.read.data  		= $.extend(data.transport.read.data,{
												resource	:"service"
												,service	:"meteo"
											});
			
			dataSource = new kendo.data.DataSource(data);
			that.set("meteo", dataSource);
		}
	});
	pompierModel = kendo.data.ObservableObject.extend(
	{
		pompier : null
		,init	: function()
		{
			var that = this,
				dataSource;
			
			kendo.data.ObservableObject.fn.init.apply(that, []);
			
			var data 						= mainClass._defaultDataSourceParameters();
			data.transport.read.data  		= $.extend(data.transport.read.data,{
												resource	:"service"
												,service	:"pompier"
											});
			
			dataSource = new kendo.data.DataSource($.extend(data,
				{
					change : function()
					{
						$("#pompierContainer").html(kendo.render(kendo.template($("#pompier-page-template").html()), this.view()));
					}	
				}));
			that.set("pompier", dataSource);	
		}
	});
	changeModel = kendo.data.ObservableObject.extend(
	{
		change : null
		,init	: function()
		{
			var that = this,
				dataSource;
			
			kendo.data.ObservableObject.fn.init.apply(that, []);
			
			var data 						= mainClass._defaultDataSourceParameters();
			data.transport.read.data  		= $.extend(data.transport.read.data,{
												resource	:"service"
												,service	:"change"
											});
			
			dataSource = new kendo.data.DataSource(data);
			that.set("change", dataSource);	
		}
	});
	pharmacieModel = kendo.data.ObservableObject.extend(
	{
		pharmacie : null
		,init	: function()
		{
			var that = this,
				dataSource;
			
			kendo.data.ObservableObject.fn.init.apply(that, []);
			
			var data 						= mainClass._defaultDataSourceParameters();
			data.transport.read.data  		= $.extend(data.transport.read.data,{
												resource	:"service"
												,service	:"pharmacie"
											});
			
			dataSource = new kendo.data.DataSource($.extend(data,{
				group : {field:"category"}
			}));
			that.set("pharmacie", dataSource);	
		}
	});
	
	app.service = {
		homeViewModel 					: new homeModel()
		,menuViewModel					: new menuModel()
		,categoryViewModel				: new categoryModel()
		,filInfoViewModel				: new filInfoModel()
		,flashInfoViewModel				: new flashInfoModel()
		,categoryBoutPortantViewModel 	: new categoryBoutPortantModel()
		,archiveViewModel				: new archiveModel()
		,articleViewModel				: new articleModel()
		,commentViewModel				: new commentsModel()
		,meteoViewModel					: new meteoModel()
		,changeViewModel				: new changeModel()
		,pharmacieViewModel				: new pharmacieModel()
		,pompierViewModel				: new pompierModel()
		,settingsViewModel				: new settingsModel()
		,homeViewShow		: function()
		{
			mainClass._showFooterMenu();
		}
		,sendMessage		: function()
		{
			var dataToPost      = $("#contactForm").serialize();
			var __dataRequest 	= mainClass._prepareDataForRequest();
			var __formValidator = $("#contactForm").kendoValidator({validateOnBlur:true}).data("kendoValidator");
			if(__formValidator.validate() == true)
			{
				$.ajax(
				{
					url 		: __dataRequest.url+"/index.php?option=com_api&app=content&resource=contact&key="+__dataRequest.data.key
					,type 		: "post"
					,dataType 	: "jsonp"
					,data		: dataToPost
					,success	: function(data){
						var _data  = data;						
	                    var _title = "Information";
						navigator.notification.alert(_data.message,null,_title,"OK");
						navigator.notification.beep(2);
					}
					,beforeSend : function(){
						showLoading();
					}
					,complete : function(){
						hideLoading();
					}
				});
			}
		}
		,goBack				: function()
		{
			app.application.navigate("#:back");
		}
		,saveSettings		: function()
		{
			var _formInput 		= $("#settingsView input[data-role='switch']");
			var _settings		= mainClass.settings.Application.bottomMenuToShow;
			var _newSettings 	= [];
			
			_formInput.each(function(index,elem)
			{
				var _elem 			 = $(elem).data("kendoMobileSwitch");
				var _newSettingsElem = null;
				$.each(_settings,function(i,setting){
					if(setting.name == $(elem).attr("name")){
						_newSettingsElem = $.extend(setting,{show:_elem.check()});
						return false;
					}
				});
				_newSettings.push(_newSettingsElem);
			});
			mainClass.settings.Application.bottomMenuToShow = _newSettings;
			window.localStorage.setItem("settings",JSON.stringify(mainClass.settings));
			app.application.navigate("#/");
		}
		,showListingArticle	: function(e)
		{
			$(".category-listing-container").empty();
			var categorySource 									= app.service.categoryViewModel.get("categorySource");
			categorySource.transport.options.read.data.id 		= e.view.params.id;
			$("#linkCategoryView").attr("href","#categoryView?id="+e.view.params.id);
			app.service.categoryViewModel.categorySource 		= categorySource;
			app.service.categoryViewModel.categorySource.read();
		}
		,beforeShowArticle  : function(e){
			$("#articleContainer").empty();
		}
		,showArticle		: function(e)
		{
			var tabstrip 	= $("#articleTabstrip").data("kendoMobileTabStrip");

			if(tabstrip!=undefined && tabstrip!=null)
				tabstrip.clear();

			$("#linkArticleView").attr("href","#articleView?id="+e.view.params.id);
			var articleSource = app.service.articleViewModel.get("article");
			articleSource.transport.options.read.data.id = e.view.params.id;
			app.service.articleViewModel.articleSource = articleSource;
			app.service.articleViewModel.articleSource.read();
		}
		,showComments		: function(e)
		{
			$("#no-comments").hide();
			$("#commentsList").empty();
			var idArticle = $(e.target).data("id");
			var commentSource = app.service.commentViewModel.get("comments");
			app.service.commentViewModel.idArticle		 = idArticle;
			commentSource.transport.options.read.data.id = idArticle
			app.service.commentViewModel.comments = commentSource;
			app.service.commentViewModel.comments.read();
		}
		,sendComment 		: function()
		{
			var __formValidator = $("#commentsForm").kendoValidator({validateOnBlur:true}).data("kendoValidator");
			var __dataRequest 	= mainClass._prepareDataForRequest();
			
			if(__formValidator.validate() === true )
			{
				$.ajax(
				{
					url 		: __dataRequest.url+"/index.php?option=com_api&app=content&resource=comment&key="+__dataRequest.data.key
					,type 		: "post"
					,dataType 	: "jsonp"
					,data		: $("#commentsForm").serialize()+"&itemId="+that.idArticle
					,success	: function(data)
					{
						var __commentList = $("#commentsList").data("kendoMobileListView");
						that.get("comments").read();
						__commentList.refresh();
						$("#commentsForm").trigger("reset");
					}
					,beforeSend : function(){
						showLoading();
					}
					,complete : function(){
						hideLoading();
					}
				});
			}
		}
		,downloadPdfFile	: function(e)
		{
			var self			 = $(e.target);
			var __linkToDownload = encodeURI(self.data("filepath"));
			var __fileName		 = self.data("filename");
			var downloadInstance = new downloadClass();
			showLoading();
			downloadInstance.run(__linkToDownload,__fileName,"archive-laverite");
		}
		,openBrowser			: function(e)
		{
			var __link = $(e.button).data("link");
			cordova.InAppBrowser.open(__link,"_system","location=yes");
		}
		,closeModalView		: function(e)
		{
			var modalView 		= e.sender.element.closest("[data-role=modalview]").data("kendoMobileModalView");
			var _validatorForm 	= $("#commentsForm").kendoValidator().data("kendoValidator");
			if(_validatorForm != undefined){
				_validatorForm.hideMessages();
			}
			modalView.close();
		}
	};
})(jQuery,  window);